"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const antlr4ts_1 = require("antlr4ts");
const Decorators_1 = require("antlr4ts/Decorators");
class RpsErrorStrategy extends antlr4ts_1.DefaultErrorStrategy {
    //Not working
    reportNoViableAlternative(recognizer, e) {
        // throw new Error(e.message);
    }
}
__decorate([
    Decorators_1.Override
], RpsErrorStrategy.prototype, "reportNoViableAlternative", null);
exports.RpsErrorStrategy = RpsErrorStrategy;
class ErrorCollectorListener {
    syntaxError(recognizer, offendingSymbol, line, charPositionInLine, msg, e) {
        console.error("Problem encountered :" + msg);
        this.underlineError(recognizer, offendingSymbol, line, charPositionInLine);
    }
    underlineError(recognizer, offendingToken, line, pos) {
        let tokens = recognizer.inputStream;
        // console.log(tokens.tokenSource);
        let input = tokens.tokenSource.inputStream.toString();
        let lines = input.split('\n');
        let errorLine = lines[line - 1];
        let start = offendingToken.startIndex;
        let stop = offendingToken.stopIndex;
        console.log(errorLine);
        for (var i = 0; i < pos; i++)
            process.stdout.write(" ");
        if (start >= 0 && stop >= 0)
            for (var i = start; i < stop + 1; i++)
                process.stdout.write("^");
        console.log('');
    }
}
exports.ErrorCollectorListener = ErrorCollectorListener;
